REM liste les tablespaces dont tous les datafiles sont au dessus d'une valeur seuil (donne en argument)
REM ----------------------------------------------------------------------------------------------------

ACCEPT pct_occupation_max CHAR PROMPT 'valeur seuil d alerte au-dela du quel le tablespace risque de saturer : '

select d.tablespace_name, count(d.file_name)
from (
select tablespace_name tbname,file_id freeid, sum(bytes) free
from dba_free_space
group by tablespace_name, file_id
) e, DBA_DATA_FILES d 
where d.file_id=e.freeid(+)
and (d.bytes-nvl(e.free,0))/d.bytes >= $pct_occupation_max/100 
group by d.tablespace_name
having count(d.file_name)=
(
select count(f.file_name)
from
dba_data_files f
where
  f.autoextensible<>'YES' and
  f.tablespace_name=d.tablespace_name and
  f.tablespace_name not like 'PERFDATA' and
  f.tablespace_name not like 'SYSAUX' and
  f.tablespace_name not like '%RBS%' and
  f.tablespace_name not like '%TEMP%' and
  f.tablespace_name not like '%ROLLBACK%' and 
  f.tablespace_name not like '%TMP%' and
  f.tablespace_name not like '%UNDO%' /* and
  f.file_name not like 'RBS.DBF' */
)
;